#ifndef SERAILPORT_H
#define SERAILPORT_H

#include <QObject>
#include<QtSerialPort>
#include <QSerialPortInfo>
#include <qlineedit.h>


class SerailPort : public QObject //QIODevice //
{
    Q_OBJECT
public:
    QSerialPort *serial;//定义一个串口 serial = new QSerialPort();
    const QStringList  strBautRate = {"1200", "2400", "9600", "19200", "38400", "115200"};
    const QStringList  strDataBit = {"5", "6", "7", "8"};
    const QStringList  strParityRate = {"None", "Even", "Odd", "Mark", "Space"};
    const QStringList  strStopRate = {"1", "1.5", "2"};



private:
    bool bPorStatus = false;
    QLineEdit *pRecvLineEdit;

public:
    explicit SerailPort(QObject *parent = nullptr);

    bool getPorStatus()
    {
        return  bPorStatus;
    };

    void setPorStatus(bool bStatus)
    {
        bPorStatus = bStatus;

    };

    void setUi(QLineEdit *pRecvtext )
    {
        pRecvLineEdit = pRecvtext;
    };

    QStringList getAllPorts();

    QStringList getAllBautRate()
    {
        return  strBautRate;
    };

    QStringList getAllDataBit()
    {
        return  strDataBit;
    };

    QStringList getAllParityRate()
    {
        return  strParityRate;
    };

    QStringList getAllStopRate()
    {
        return  strStopRate;
    };
    void sendtext(QString strsend);


public slots:
    void readyRead();//当串口有消息来的时候调用的槽函数




};

#endif // SERAILPORT_H
